SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE FUNCTION [dbo].[BatchDetailedTransactionRateCalculate]
(	
	@SystemService VARCHAR(50),
	@RatePerSecond DECIMAL(18, 5),
	@SecondsBilling INT,
	@RatePerTransaction DECIMAL(18, 5),
	@TotalRequest INT,
	@IsValid BIT,
	@Description VARCHAR(50),
	@IsDemo BIT
)
RETURNS DECIMAL(18,5)
WITH SCHEMABINDING AS  
BEGIN  
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL VALOR TOTAL 
	DECLARE @TotalRate DECIMAL(18, 5)  
	DECLARE @ValidValue INT = 0

	-- EN EL CASO DE TRANCRIPCIONES SE CALCULA LA TARIFA POR SEGUNDO * SEGUNDOS FACTURADOS
	IF @SystemService = 'TRANSCRIPTION' 
	BEGIN
		IF @IsValid = 0 OR @Description <> 'SUCCED'
			SET @ValidValue = 0
		ELSE 
			SET @ValidValue = 1

		SET @TotalRate = @RatePerSecond * @SecondsBilling * @ValidValue
	
	END
	-- EN EL CASO DE ANALISIS SEMANTICO Y COGNITICO SE CALCULA LA TARIFA POR TRANSACCION * 1 (HASTA QUE SE CAMBIE EL CRITERIO)
	ELSE
	BEGIN 
		-- EN UN INICIO PARA COGNITIVE, SI ES DEMO EL COSTO ES 0
		IF @IsDemo = 1 
			SET @ValidValue = 0
		ELSE 
			SET @ValidValue = 1

		SET @TotalRate = @RatePerTransaction * @TotalRequest * @ValidValue
	END

	RETURN @TotalRate

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
