SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE FUNCTION [dbo].[BatchSummaryTransactionRateCalculate]
(	
	@BatchId VARCHAR(100),
	@SystemService VARCHAR(50)
)
RETURNS DECIMAL(18,5)
  AS  
BEGIN  
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL VALOR TOTAL 
	DECLARE @TotalRate DECIMAL(18, 5)  

	IF @SystemService = 'TRANSCRIPTION'
	BEGIN
		SELECT @TotalRate = ASAVST.[ValidDurationTime] * ASAVST.[TranscriptionRatePerSecond]
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			WHERE ASAVST.[BatchId] = @BatchId
				AND ASAVST.[SystemService] = @SystemService

	END
	ELSE IF @SystemService = 'SEMANTIC_ANALYSIS'
	BEGIN
		-- SELECT @TotalRate = ASAVST.[TotalQueryRequest] * ASAVST.[SemanticAnalysisRatePerTransaction]
		SELECT @TotalRate = ASAVST.[ValidTotalQueries] * ASAVST.[SemanticAnalysisRatePerTransaction]
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			WHERE ASAVST.[BatchId] = @BatchId
				AND ASAVST.[SystemService] = @SystemService

	END
	ELSE IF @SystemService = 'COGNITIVE_ANALYSIS'
	BEGIN
		SELECT @TotalRate = ASAVST.[TotalModelRequest] * ASAVST.[CognitiveAnalysisRatePerTransaction]
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			WHERE ASAVST.[BatchId] = @BatchId
				AND ASAVST.[SystemService] = @SystemService
	END
	
	RETURN ISNULL(@TotalRate, 0)

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
