SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[AccountSubAccountVCCBulkCloseBatchDetail]
AS
BEGIN
	-- INSERT INTO [dbo].[TMP_TABLE_CLOSE] ([PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [ResultCode], [ResultDescription])
	-- SELECT [PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [ResultCode], [ResultDescription] FROM #AccountSubAccountVCCBulkCloseBatchDetailTemp;
	-- SELECT * FROM [dbo].[TMP_TABLE_CLOSE] 
	-- TRUNCATE TABLE [dbo].[TMP_TABLE_CLOSE] 

	-- ESTE PROCEDURE TIENE LA FUNCION DE ACTUALIZAR  A ISFINISHED = 1 UN BLOQUE DE DATA EXISTENTE EN LA TABLA DETALLE DE TRANSACCION
	-- A PARTIR DE UNA TABLA TEMPORAL
	
	-- HACEMOS EL UPDATE MARCAR COMO FINALIZADO UN BLOQUE DE REGISTROS DE LA TABLA TRANSACTION DETAILED 
	UPDATE ASAVDT
	SET ASAVDT.[IsFinished] = 1
		,ASAVDT.[IsValid] = ASAVDTTMP.[ResultCode]
		,ASAVDT.[Description] = ASAVDTTMP.[ResultDescription]
		,ASAVDT.[TimeStamp] = GETUTCDATE()
		,ASAVDT.[LastModifiedDate] = GETUTCDATE()
	FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT 
	INNER JOIN #AccountSubAccountVCCBulkCloseBatchDetailTemp ASAVDTTMP
	--INNER JOIN [dbo].[TMP_TABLE_CLOSE] ASAVDTTMP 
		ON ASAVDTTMP.[InstallationId] = ASAVDT.[InstallationId]
			AND ASAVDTTMP.[VCC] = ASAVDT.[VCC]
			AND ASAVDTTMP.[BatchTypeName] = ASAVDT.[BatchTypeName]
			AND ASAVDTTMP.[BatchTypeId] = ASAVDT.[BatchTypeId]
			AND ASAVDTTMP.[SystemService] = ASAVDT.[SystemService]
			AND ASAVDTTMP.[EntityId] = ASAVDT.[EntityId]
	WHERE ASAVDTTMP.[InstallationId] IS NOT NULL
		AND (ASAVDT.[IsFinished] = 0 OR ASAVDT.[IsFinished] IS NULL)

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS BATCH RELACIONADOS EN EL CIERRE
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY
		FOR 
		-- CONSULTAMOS LOS BATCH RELACIONADO A LA ACTUALIZACION DE LOS DETALLES MARCADOS COMO FINALIZADOS
		SELECT DISTINCT ASAVDT.[BatchId],
						ASAVDT.[SystemService]
			FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT 
			INNER JOIN #AccountSubAccountVCCBulkCloseBatchDetailTemp ASAVDTTMP 
			--INNER JOIN [dbo].[TMP_TABLE_CLOSE] ASAVDTTMP 
				ON ASAVDTTMP.[InstallationId] = ASAVDT.[InstallationId]
					AND ASAVDTTMP.[VCC] = ASAVDT.[VCC]
					AND ASAVDTTMP.[BatchTypeName] = ASAVDT.[BatchTypeName]
					AND ASAVDTTMP.[BatchTypeId] = ASAVDT.[BatchTypeId]
					AND ASAVDTTMP.[SystemService] = ASAVDT.[SystemService]
					AND ASAVDTTMP.[EntityId] = ASAVDT.[EntityId]
			WHERE ASAVDTTMP.[InstallationId] IS NOT NULL
				AND ASAVDT.[IsFinished] = 1

	-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL BACTH ACTUAL QUE ESTAMOS RECORRIENDO
	DECLARE @CURRENT_BATCH_TO_UPDATE VARCHAR(50) = ''
	DECLARE @CURRENT_SYSTEM_SERVICE VARCHAR(50) = ''

	-- DECLARAMOS VARIABLES PARA ALMACENAR LOS DATOS RESUMEN
	DECLARE @CET_TOTAL_REQUEST INT = 0
	DECLARE @CET_TOTA_VALID_AUDIO INT = 0
	DECLARE @CET_TOTAL_VALID_ASYNC_DETAIL INT = 0
	DECLARE @CET_TOTAL_INVALID_AUDIO INT = 0
	DECLARE @CET_TOTAL_INVALID_ASYNC_DETAIL INT = 0
	DECLARE @CET_VALID_DURATION_TIME INT = 0
	DECLARE @CET_ROUNDED_DURATION_TIME INT = 0
	DECLARE @CET_VALID_TOTAL_QUERIES INT = 0
	DECLARE @CET_INVALID_TOTAL_QUERIES INT = 0
	DECLARE @CET_VALID_TOTAL_MODELS INT = 0
	DECLARE @CET_INVALID_TOTAL_MODELS INT = 0
	DECLARE @CET_TOTAL_CALL_PHRASES INT = 0
	DECLARE @CET_TOTAL_TEXT_PHRASES INT = 0
	DECLARE @CET_TOTAL_RAW_CHAR INT = 0
	DECLARE @CET_TOTAL_VALID_CHAR INT = 0

	
	-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_BATCH_TO_UPDATE, @CURRENT_SYSTEM_SERVICE
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		WITH 
		-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DEL RESUMEN PARA LA ACTUALIZACION
		CteTransactionDetailSummary AS (
			SELECT ASAVDT.[BatchID],
					ASAVDT.[SystemService],
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[ValidDurationTime] ELSE 0 END) 'ValidDurationTime',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN CEILING(ASAVDT.[ValidDurationTime] * 1.00 / 60) * 60 ELSE 0 END) 'RoundedDurationTime',
					SUM(ASAVDT.[TotalRequest]) 'TotalRequest',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN 1 ELSE 0 END) 'ValidAudio',
					SUM(CASE WHEN ASAVDT.[IsValid] = 0 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] <> 'SUCCED'  THEN 1 ELSE 0 END) 'InvalidAudio',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] <> 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN 1 ELSE 0 END) 'ValidAsyncDetail',
					SUM(CASE WHEN ASAVDT.[IsValid] = 0 AND ASAVDT.[Channel] <> 'CALL' AND ASAVDT.[Description] <> 'SUCCED'  THEN 1 ELSE 0 END) 'InvalidAsyncDetail',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[TotalPhrases] ELSE 0 END) 'TotalCallPhrases',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] <> 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[TotalPhrases] ELSE 0 END) 'TotalTextPhrases',
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[RawChar] ELSE 0 END) 'TotalRawChar', -- RAWCHAR ES EL TOTAL CARACTERES DEL JSON DESCARGADO DEL REPOSITORIO PARA LAS INTERACCIONES TEXT
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Channel] = 'CALL' AND ASAVDT.[Description] = 'SUCCED' THEN ASAVDT.[ValidChar] ELSE 0 END) 'TotalValidChar', -- VALID ES EL TOTAL CARACTERES DEL JSON PROCESADO POR IDATHA PARA TODAS LAS INTERACCIONES
					SUM(CASE WHEN ASAVDT.[IsValid] = 1 AND ASAVDT.[Description] = 'SUCCED' THEN 1 ELSE 0 END) 'ValidTotalQueries',
					SUM(CASE WHEN ASAVDT.[IsValid] = 0 AND ASAVDT.[Description] <> 'SUCCED'  THEN 1 ELSE 0 END) 'InvalidTotalQueries'
				FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT (NOLOCK) 
				WHERE ASAVDT.[BatchID] = @CURRENT_BATCH_TO_UPDATE
					AND ASAVDT.[SystemService] = @CURRENT_SYSTEM_SERVICE
				GROUP BY ASAVDT.[BatchID], ASAVDT.[SystemService]
		)
		
		--SELECT * FROM CteTransactionDetailSummary
		-- CAPTURAMOS LOS RESULTADOS DE LA CET PARA USARLOS MAS DE UNA VEZ
		SELECT @CET_TOTAL_REQUEST = ASAVDT.[TotalRequest],
				@CET_TOTA_VALID_AUDIO = ASAVDT.[ValidAudio],
				@CET_TOTAL_VALID_ASYNC_DETAIL = ASAVDT.[ValidAsyncDetail],
				@CET_TOTAL_INVALID_AUDIO = ASAVDT.[InvalidAudio],
				@CET_TOTAL_INVALID_ASYNC_DETAIL = ASAVDT.[InvalidAsyncDetail],
				@CET_VALID_DURATION_TIME = ASAVDT.[ValidDurationTime],
				@CET_ROUNDED_DURATION_TIME = ASAVDT.[RoundedDurationTime],
				@CET_VALID_TOTAL_QUERIES = ASAVDT.[ValidTotalQueries],
				@CET_TOTAL_CALL_PHRASES = ASAVDT.[TotalCallPhrases],
				@CET_TOTAL_TEXT_PHRASES = ASAVDT.[TotalTextPhrases],
				@CET_TOTAL_RAW_CHAR = ASAVDT.[TotalRawChar],
				@CET_TOTAL_VALID_CHAR = ASAVDT.[TotalValidChar]
			FROM CteTransactionDetailSummary ASAVDT (NOLOCK)
			WHERE ASAVDT.[BatchID] = @CURRENT_BATCH_TO_UPDATE
				AND ASAVDT.[SystemService] = @CURRENT_SYSTEM_SERVICE
		
		-- POR CADA SERVICIO DEL SISTEMA FINALIZADO, SE DEBA ACTUALIZAR EL CAMPO CORRESPONDIENTE EN LA SUMMARY
		UPDATE ASAVST
			SET ASAVST.[ValidDurationTime] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_VALID_DURATION_TIME ELSE ASAVST.[ValidDurationTime] END 
				,ASAVST.[RoundedDurationTime] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_ROUNDED_DURATION_TIME ELSE ASAVST.[RoundedDurationTime] END 
				,ASAVST.[TotalQueryRequest] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' THEN @CET_TOTAL_REQUEST ELSE ASAVST.[TotalQueryRequest] END 
				,ASAVST.[ValidTotalQueries] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' THEN @CET_VALID_TOTAL_QUERIES ELSE ASAVST.[ValidTotalQueries] END 
				,ASAVST.[TotalModelRequest] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'COGNITIVE_ANALYSIS' THEN @CET_TOTAL_REQUEST ELSE ASAVST.[TotalModelRequest] END
				,ASAVST.[ValidTotalAudio] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTA_VALID_AUDIO ELSE ASAVST.[ValidTotalAudio] END 
				,ASAVST.[ValidTotalAsyncDetail] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_VALID_ASYNC_DETAIL ELSE ASAVST.[ValidTotalAsyncDetail] END 
				,ASAVST.[InvalidTotalAudio] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_INVALID_AUDIO ELSE ASAVST.[InvalidTotalAudio] END 
				,ASAVST.[InvalidTotalAsyncDetail] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_INVALID_ASYNC_DETAIL ELSE ASAVST.[InvalidTotalAsyncDetail] END 
				,ASAVST.[TotalCallPhrases] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_CALL_PHRASES ELSE ASAVST.[TotalCallPhrases] END 
				,ASAVST.[TotalTextPhrases] = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_TEXT_PHRASES ELSE ASAVST.[TotalTextPhrases] END 
				,ASAVST.[RawChar]  = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_RAW_CHAR ELSE ASAVST.[RawChar] END 
				,ASAVST.[ValidChar]  = CASE WHEN @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' THEN @CET_TOTAL_VALID_CHAR ELSE ASAVST.[ValidChar] END 
				,ASAVST.[IsFinished] = 1 -- <- VALIDAR UNA FORMA DE ELIMINAR ESTA LINEA YA QUE DE ESTE DATO SE ENCARGA EL CLOSEBATCH
				,ASAVST.[LasModifiedDate] = GETUTCDATE()
				,ASAVST.[TimeStamp] = GETUTCDATE()
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			/*INNER JOIN CteTransactionDetailSummary ASAVDT (NOLOCK)
				ON ASAVDT.[BatchID] = ASAVST.[BatchID]
					AND ASAVDT.[SystemService] = ASAVST.[SystemService]*/
			WHERE ASAVST.[BatchID] = @CURRENT_BATCH_TO_UPDATE
				AND ASAVST.[SystemService] = @CURRENT_SYSTEM_SERVICE
				--AND ASAVST.[IsFinished] = 0 
	
		IF @@ROWCOUNT = 0 
			RAISERROR('DATABABASE_ERROR_SYSTEM_SERVICE_SUMMARY_UPDATE_FAILED', 16, 16)

		-- EN CASO NUESTRO SYSTEM_SERVICE SEA TRANSCRIPCION, ACTUALIZAMOS EL VALIDDURATIONTIME, TOTALVALIDAUDIO Y TOTALINVALIDAUDIO DE LOS OTROS SYSTEMSERVICE(SEMANTIC Y COGNITIVE)
		IF @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION'
		BEGIN
			UPDATE ASAVST
				SET ASAVST.[ValidDurationTime] = @CET_VALID_DURATION_TIME 
					,ASAVST.[ValidTotalAudio] = @CET_TOTA_VALID_AUDIO
					--,ASAVST.[InvalidTotalAudio] = @CET_TOTAL_INVALID_AUDIO
					,ASAVST.[ValidTotalAsyncDetail] = @CET_TOTAL_VALID_ASYNC_DETAIL
					,ASAVST.[EndDate] = GETUTCDATE()
					,ASAVST.[LasModifiedDate] = GETUTCDATE()
					,ASAVST.[TimeStamp] = GETUTCDATE()
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
				WHERE ASAVST.[BatchID] = @CURRENT_BATCH_TO_UPDATE
					AND ASAVST.[SystemService] IN ('SEMANTIC_ANALYSIS', 'COGNITIVE_ANALYSIS')
		END
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_BATCH_TO_UPDATE, @CURRENT_SYSTEM_SERVICE
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR

	-- TERMINADO EL PROCESO ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE #AccountSubAccountVCCBulkCloseBatchDetailTemp
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
