SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[CreateMainAccountBalance] (
	@PlatformHash VARCHAR(100) = NULL,
	@AccountId VARCHAR(100) = NULL,
	@Balance DECIMAL(18,5) = 0,
	@User VARCHAR(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- VERIFICAMOS SI EXISTE EL REGISTRO DE SALDOS EN ACCOUNTSUBACCOUNBVCCGENERAL
	--IF @@ROWCOUNT > 0
	IF EXISTS (
		SELECT AB.[ID] 
			FROM dbo.[AccountBalance] AB 
			WHERE AB.[PlatformHash] = @PlatformHash
				AND AB.[AccountId] = @AccountId
	)
	BEGIN 
		-- SI YA EXISTE UN REGISTRO DE PLATAFORMA CON ACCOUNTID HACEMOS UPDATE
		UPDATE dbo.[AccountBalance] 
			SET [AvailableBalance] = @Balance 
				, [TotalBalance] = @Balance 
				, [LastModifiedByUserId] = @User
				, [LastModifiedDate] = GETUTCDATE()
			WHERE [PlatformHash] = @PlatformHash
				AND [AccountId] = @AccountId 
				AND [SubAccountId] IS NULL
	END
	ELSE
	BEGIN 
		-- SI NO EXISTE UN REGISTRO DE PLATAFORMA CON ACCOUNTID HACEMOS INSERT Y SETTEAMOS EL SALDO DISPONIBLE Y TOTAL 
		
		--INSERT dbo.[AccountBalance] ([PlatformHash], [ID], [AccountId], [TotalBalance], [AvailableBalance], [CreatedByUserId])
			--VALUES (@PlatformHash, NEWID(), @AccountId, @Balance, @Balance, @User)

		-- EJECUTAMOS EL SP QUE CREA EL REGISTRO EN ACCOUNTBALANCE Y LOS RESPECTIVOS REGISTROS EN LA TABLA DE MOVIMIENTOS
		EXEC [dbo].[AccountSubAccountVCCBalanceCreate] @PlatformHash, NULL, @AccountId, NULL, NULL, @Balance, @User
			
	END

	/*
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL SERVICIO DEL SISTEMA RECORRIDO
	DECLARE @SYSTEM_SERVICE VARCHAR(50)

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL SPLIT DE SERVICIOS DEL SISTEMA
	DECLARE MY_SYSTEM_SERVICES_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY
		FOR 

		-- BUSCAMOS LOS SERVICIOS DEL SISTEMA QUE NO ESTAN ASOCIADOS A LA CUENTA PRINCIPAL
		SELECT SS.[SystemServiceId]		
			FROM dbo.[SystemService] SS (NOLOCK)
			LEFT JOIN dbo.[AccountBalance] AB (NOLOCK)
				ON AB.[SystemService] = SS.[SystemServiceId]
					AND AB.[PlatformHash] = @PlatformHash
			WHERE AB.[AccountId] IS NULL 

	-- ABRIMOS Y RECORREMOS EL ARRAY DE SERVICIOS
	OPEN MY_SYSTEM_SERVICES_CURSOR
	FETCH NEXT FROM MY_SYSTEM_SERVICES_CURSOR INTO @SYSTEM_SERVICE
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- DECLARAMOS UNA VARIABLE PARA EL SALDO INICIAL DEL PRODUCTO ACTUAL
		DECLARE @SERVICE_INITIAL_BALANCE DECIMAL(18,5)
		
		-- SETTEAMOS EL SALDO INICIAL DEL PRODUCTO EN 0
		SET @SERVICE_INITIAL_BALANCE = 0

		-- COMO ESTAMOS REGISTRANDO POR PRIMERA VEZ TODOS LOS PRODUCTOS PARA LA PLATAFORMA, TODO EL SALDO INICIAL VA DIRIGIDO A FREE
		IF @SYSTEM_SERVICE = 'FREE' 
			SET @SERVICE_INITIAL_BALANCE = @Balance

		-- EJECUTAMOS EL INSERT A ACCOUNTBALANCE 
		INSERT INTO [dbo].[AccountBalance]
				   ([PlatformHash]
				   ,[AccountId]
				   ,[SystemService]
				   ,[CountableBalance]
				   ,[AvailableBalance]
				   ,[RetainedBalance]
				   ,[IsLocked]
				   ,[CreatedDate]
				   ,[CreatedByUserId]
				   ,[TimeStamp])
			 VALUES
				   (@PlatformHash
				   ,@AccountId
				   ,@SYSTEM_SERVICE
				   ,@SERVICE_INITIAL_BALANCE
				   ,@SERVICE_INITIAL_BALANCE
				   ,0
				   ,0
				   ,GETUTCDATE()
				   ,@User
				   ,GETUTCDATE())
		
		--Do something with Id here
		-- PRINT @SYSTEM_SERVICE
		FETCH NEXT FROM MY_SYSTEM_SERVICES_CURSOR INTO @SYSTEM_SERVICE
	END
	CLOSE MY_SYSTEM_SERVICES_CURSOR
	DEALLOCATE MY_SYSTEM_SERVICES_CURSOR
	*/
	-- RETORNAMOS UN VALOR DE RESPUESTA
	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
