SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAccountVcc]
(
	@InstallationId						VARCHAR(100),
	@VCC								VARCHAR(50)
)
AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON;

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
        
		-- DECLARAMOS UNA TABLE PARA ALMACENAR EL RESULTADO DEL SP
		DECLARE @SP_RESULT AS TABLE ([result] INT)
		
		-- EJECUTAMOS EL SP Y GUARDAMOS EL RESULTADO EN LA TABLA CREADA
		INSERT @SP_RESULT EXEC [dbo].[GetAccountStatusByVcc] @InstallationId, @VCC, 0

		-- HACEMOS LAS BUSQUEDA DEL VCC POR EL INSTALLATIONID Y NOMBRE DEL VCC
		SELECT AV.[InstallationId] 'installationId',
				AV.[AccountId] 'accountId',
				AV.[SubAccountId] 'subAccountId',
				AV.[VCC] 'vcc'
			FROM dbo.[AccountVCC] AV (NOLOCK)
			WHERE AV.[InstallationId] = @InstallationId
				AND AV.[VCC] = @VCC

    END TRY
    BEGIN CATCH
        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
