SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetSubAccountsBalance]
(
	@AccountId				VARCHAR(50) = NULL,
	@InstallationId			VARCHAR(100) = NULL
)
AS
BEGIN
	-- ESTE SP RECUPERA TODAS LAS SUBCUENTAS CON SUS SALDOS DISPONIBLES
	SET NOCOUNT ON

	SELECT [PlatformHash]				'platformHash',
			[ID]						'id',
			[InstallationId]			'installationId',
			[AccountId]					'accountId',
			[SubAccountId]				'subAccountId',
			[TotalBalance]				'totalBalance',
			[AvailableBalance]			'availableBalance',
			[AssignedBalance]			'assignedBalance',
			[IsLocked]					'isLocked'
	FROM [dbo].[AccountBalance]  (NOLOCK)
	WHERE [AccountId] = @AccountId  AND [InstallationId]=@InstallationId AND [SubAccountId] IS NOT NULL
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
