SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[ReportByVCCBalanceByPeriod] (
	@PlatformHash VARCHAR(100)=NULL,
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@InstallationId VARCHAR(100)=NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@UserApi VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL,	
	@Slice INT = 1	
	)
AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD HACER UN REPORTE DETALLADO DE TRANSACCIONES
	SET NOCOUNT ON
	
	SELECT
      case @Slice
        when 1 then Dateadd(DAY,datediff(DAY, 0, AST.enddate), 0)
        when 30 then Dateadd(MONTH,datediff(MONTH, 0, AST.enddate), 0)
        else Dateadd(DAY,datediff(DAY, 0, AST.enddate), 0)
      end as 'COLUMN_PERIOD',
	  AST.[BatchTypeName]                                             'COLUMN_BATCH_TYPE_NAME',
	  AST.[UserApi]                                                   'COLUMN_API_USER',
      SUM(AST.[Rate]) as 'COLUMN_TOTAL_RATE'          
    FROM [AccountSubAccountVCCSummaryTransaction] ast
    --LEFT JOIN [AccountSubAccountVCCDetailedTransaction] ADT (NOLOCK)
       --ON ADT.[BatchId] = AST.[BatchID]
    WHERE AST.[InstallationId] IS NOT NULL
        AND   (@InstallationId IS NULL OR AST.[InstallationId] = @InstallationId)
        AND   (@VCC IS NULL OR AST.[VCC] = @VCC)
        AND   (@StartDate IS NULL OR AST.[EndDate] >= @StartDate)
        AND   (@EndDate IS NULL OR AST.[EndDate] <= @EndDate)
        AND   (@BatchTypeName IS NULL OR AST.[BatchTypeName] = @BatchTypeName)
        AND   (@BatchTypeId IS NULL OR AST.[BatchTypeId] = @BatchTypeId)
        AND   (@UserApi IS NULL OR AST.[UserApi] = @UserApi)
        --AND   (@AccountId IS NULL OR ADT.[AccountId] = @AccountId)
        --AND   (@SubAccountId IS NULL OR ADT.[SubAccountId] = @SubAccountId)
    GROUP BY
    case @Slice
        when 1 then Dateadd(DAY,datediff(DAY, 0, AST.enddate), 0)
        when 30 then Dateadd(MONTH,datediff(MONTH, 0, AST.enddate), 0)
    else Dateadd(DAY,datediff(DAY, 0, AST.enddate), 0) end,
    AST.BatchTypeName,
    AST.UserApi
    ORDER BY MIN(AST.EndDate),AST.BatchTypeName,
    AST.UserApi

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
