SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE Procedure [dbo].[ReportConsumeDetailByEntity]
(
	@InstallationId Varchar(150),
	@StartDate Varchar(50),
	@EndDate Varchar(50),
	@VCC Varchar(150)  = NULL
)

As
BEGIN

	--Declare @Slice Int = 1
	Select 
		  A.BatchTypeName As 'COLUMN_BATCH_TYPE_NAME', 
		  A.BatchTypeId As 'COLUMN_BATCH_TYPE_ID', 
		  A.TotalAudio As 'COLUMN_TOTAL_TRANSACTION', 
		  MIN(A.StartDate) As 'COLUMN_START_DATE', 
		  MAX(A.EndDate) As 'COLUMN_END_DATE', 
		  SUM(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[ValidDurationTime], 0) ELSE 0 END) As 'COLUMN_TRANSCRIPTION_VALID_DURATION_TIME', 
		  SUM(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[Rate], 0) ELSE 0 END) As 'COLUMN_TRANSCRIPTION_TOTAL_RATE', 
		  SUM(A.TotalQueries) As 'COLUMN_SEMANTIC_ANALYSIS_TOTAL_REQUEST', 
		  --SUM(CASE WHEN A.[SystemService] = 'SEMANTIC_ANALYSIS' THEN 1 ELSE 0 END) As CANTIDADAS, 
		  SUM(CASE WHEN A.[SystemService] = 'SEMANTIC_ANALYSIS' THEN ISNULL(A.[Rate], 0) ELSE 0 END) As 'COLUMN_SEMANTIC_ANALYSIS_TOTAL_RATE', 
		  SUM(A.TotalModelRequest) As 'COLUMN_COGNITIVE_ANALYSIS_TOTAL_REQUEST', 
		  SUM(CASE WHEN A.[SystemService] = 'COGNITIVE_ANALYSIS' THEN ISNULL(A.[Rate], 0) ELSE 0 END) As 'COLUMN_COGNITIVE_ANALYSIS_TOTAL_RATE' 
		From 
		  AccountSubAccountVCCSummaryTransaction (Nolock) As A 
		Where 
		  A.InstallationId = @InstallationId 
		  And A.EndDate >= @StartDate 
		  And A.EndDate <= @EndDate 
		  And A.VCC LIKE CASE WHEN @VCC is not null THEN @VCC ELSE A.VCC End 
		GROUP BY A.[BatchTypeName], A.[BatchTypeId], A.[TotalAudio]

 END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
