SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SavePlatformLicense] (
	@PlatformHash VARCHAR(100) = NULL,
	@QualityLicense INT = 0,
	@SpeechLicense INT = 0,
	@ExpirationDate DATE = NULL,
	@User VARCHAR(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE
	@InstallationId VARCHAR(100)

	SET @InstallationId = (SELECT TOP(1) InstallationId 
							FROM PlatformLicense (NOLOCK)
							WHERE PlatformHash=@PlatformHash)

	--ACTUALIZAMOS EL REGISTRO PARA QUALITY EN LA TABLA PLATFORMLICENSE
	UPDATE [dbo].[PlatformLicense]
	SET [TotalLicense] = @QualityLicense,
		[ExpirationDate] = @ExpirationDate,
		[LastModifiedDate] = GETUTCDATE(),
		[LastModifiedByUserId] = @User,
		[TimeStamp] = GETUTCDATE()
	WHERE [PlatformHash] = @PlatformHash
	AND [Product] = 'QUALITY'


	--ACTUALIZAMOS EL REGISTRO PARA SPEECH EN LA TABLA PLATFORMLICENSE
	UPDATE [dbo].[PlatformLicense]
	SET [TotalLicense] = @SpeechLicense,
		[ExpirationDate] = @ExpirationDate,
		[LastModifiedDate] = GETUTCDATE(),
		[LastModifiedByUserId] = @User,
		[TimeStamp] = GETUTCDATE()
	WHERE [PlatformHash] = @PlatformHash
	AND [Product] = 'SPEECH'

	--ACTUALIZAMO EL FECHA DE EXPIRACION EN LA TABLA PLATFORMLICENSEUSAGE
	UPDATE [dbo].[PlatformLicenseUsage]
	SET [LicenseExpirationDate] = @ExpirationDate,
		[LastModifiedDate] = GETUTCDATE(),
		[LastModifiedByUserId] = @User,
		[TimeStamp] = GETUTCDATE()
	WHERE [InstallationId] = @InstallationId
	AND [Product] = 'QUALITY'

	--ACTUALIZAMO EL FECHA DE EXPIRACION EN LA TABLA PLATFORMLICENSEUSAGE
	UPDATE [dbo].[PlatformLicenseUsage]
	SET [LicenseExpirationDate] = @ExpirationDate,
		[LastModifiedDate] = GETUTCDATE(),
		[LastModifiedByUserId] = @User,
		[TimeStamp] = GETUTCDATE()
	WHERE [InstallationId] = @InstallationId
	AND [Product] = 'SPEECH'
			
	
	-- RETORNAMOS UN VALOR DE RESPUESTA
	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
