CREATE TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] (
   [BatchID] [varchar](100) NOT NULL 
      CONSTRAINT [DF_Table_1_ID] DEFAULT (newid()),
   [InstallationId] [varchar](50) NOT NULL ,
   [VCC] [varchar](50) NOT NULL ,
   [BatchTypeName] [varchar](50) NOT NULL ,
   [BatchTypeId] [varchar](50) NULL ,
   [SystemService] [varchar](50) NOT NULL ,
   [Rate] AS ([dbo].[BatchSummaryTransactionRateCalculate]([BatchId],[SystemService])),
   [TotalInteraction] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_TotalInteraction] DEFAULT ((0))  ,
   [TotalAsync] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_TotalAsync] DEFAULT ((0))  ,
   [TotalAsyncDetail] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_TotalAsynDetail] DEFAULT ((0))  ,
   [ValidTotalAsyncDetail] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ValidTotalAsyncDetail] DEFAULT ((0))  ,
   [InvalidTotalAsyncDetail] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_InvalidTotalAsyncDetail] DEFAULT ((0))  ,
   [AlreadyTranscribedAsyncDetail] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAsyncDetail] DEFAULT ((0))  ,
   [AlreadyTranscribedRawChar] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyRawChar] DEFAULT ((0))  ,
   [AlreadyTranscribedValidChar] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyValidChar] DEFAULT ((0))  ,
   [RawChar] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_RawChar] DEFAULT ((0))  ,
   [ValidChar] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ValidChar] DEFAULT ((0))  ,
   [TotalTextPhrases] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_TotalTextPhrases] DEFAULT ((0))  ,
   [AlreadyTextPhrases] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTextPhrases] DEFAULT ((0))  ,
   [TotalSync] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_TotaSync] DEFAULT ((0))  ,
   [TotalAudio] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalAudio] DEFAULT ((0))  ,
   [ValidTotalAudio] [int] NOT NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalAudio] DEFAULT ((0))  ,
   [InvalidTotalAudio] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_InvalidTotalAudio] DEFAULT ((0))  ,
   [TotalCallPhrases] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_TotalCallPhrases] DEFAULT ((0))  ,
   [AlreadyCallPhrases] [int] NULL   ,
   [AlreadyTranscribedAudio] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAudio] DEFAULT ((0))  ,
   [AlreadyDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyDurationTime] DEFAULT ((0))  ,
   [AlreadyRoundedDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyRoundedDurationTime] DEFAULT ((0))  ,
   [AlreadyTranscribedDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedDurationTime] DEFAULT ((0))  ,
   [AlreadyTranscribedRoundedDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadeTranscribedRoundedDurationTime] DEFAULT ((0))  ,
   [DurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_DurationTime] DEFAULT ((0))  ,
   [ValidDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidDurationTime] DEFAULT ((0))  ,
   [RoundedDurationTime] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_RoundedDurationTime] DEFAULT ((0))  ,
   [TranscriptionRatePerSecond] [decimal](18,5) NULL  ,
   [TotalQueries] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalQueries] DEFAULT ((0))  ,
   [ValidTotalQueries] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalQueries] DEFAULT ((0))  ,
   [TotalQueryRequest] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_QueryRequest] DEFAULT ((0))  ,
   [SemanticAnalysisRatePerTransaction] [decimal](18,5) NULL  ,
   [TotalModels] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalModels] DEFAULT ((0))  ,
   [EstimatedRequestsPerModel] [decimal](18,5) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_StimatedRequestsPerModel] DEFAULT ((0)) ,
   [EstimatedModelRequests] [decimal](18,5) NULL  ,
   [ValidTotalModels] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalModels] DEFAULT ((0))  ,
   [TotalModelRequest] [int] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ModelRequest] DEFAULT ((0))  ,
   [CognitiveAnalysisRatePerTransaction] [decimal](18,5) NULL  ,
   [ProcessId] [varchar](100) NULL ,
   [TemplateId] [varchar](50) NULL ,
   [UserApi] [varchar](50) NULL ,
   [StartDate] [datetime] NULL   ,
   [EndDate] [datetime] NULL   ,
   [IsFinished] [bit] NOT NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_IsFinished] DEFAULT ((0))  ,
   [Status] [varchar](50) NULL 
      CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_Status] DEFAULT ('CREATED'),
   [CreatedDate] [datetime] NOT NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedDate] DEFAULT (getutcdate())  ,
   [CreatedByuserId] [varchar](50) NULL ,
   [CreatedByRemoteUser] [bit] NULL 
      CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedByRemoteUser] DEFAULT ((1))  ,
   [LasModifiedDate] [datetime] NULL   ,
   [LastModifiedByUserId] [varchar](50) NULL ,
   [LastModifiedByRemoteUser] [bit] NULL   ,
   [TimeStamp] [datetime] NOT NULL   

   ,CONSTRAINT [PK_AccountSubAccountVCCGeneralTransaction] PRIMARY KEY CLUSTERED ([BatchID], [SystemService])
)


GO
